package main


import (       
	"log"
        "os"
 	"encoding/csv"
  	"strings"
	"sort"
	"strconv"
	"time"
	"math/big"
)

	
type Midia struct {
	nome string
	tipo string
	diretor string
	autores string
	tamanho string
	genero string
	serie string
	temporada string
	possui string
	consumiu string
	deseja string
	preco string
}

type Emprestimo struct {
	pessoa string
	emprestimo string
	devolucao string
	atraso int
}

func wishlist(midias map[string]Midia, generos map[string]string){

	lista := make(map[string]Midia)

	for i, k := range midias {
		if(k.deseja ==  "x" && k.possui != "x"){
			lista[i] = k
		}
	}

        aux := map[float64][]string{}

        var aux2 []float64

        for i, k := range lista {
		s := strings.Replace(k.preco, ",", ".", -1)
		f, _ := strconv.ParseFloat(s, 64)
                aux[f] = append(aux[f], i)
        }

        for k := range aux {
                aux2 = append(aux2, k)
        }

        sort.Sort(sort.Reverse(sort.Float64Slice(aux2)))

	var listaOrdenada []string

        for _, k := range aux2 {
                for _, s := range aux[k] {
                        listaOrdenada = append(listaOrdenada, s)
                }
        }

        for i :=0 ; i+1 < len(listaOrdenada); i++ {
		for j := i+1 ; lista[listaOrdenada[i]].preco == lista[listaOrdenada[j]].preco ; j++ {
			if(lista[listaOrdenada[i]].nome > lista[listaOrdenada[j]].nome){
				x := listaOrdenada[i]
				listaOrdenada[i] = listaOrdenada[j]
				listaOrdenada[j] = x
			}
		}			
        }

	headers := []string{"Tipo","Nome","Gênero","Preço"} 

	var lines [][]string

	tipo := []string{"F","L","S"}

	for _, x := range tipo {
		for _, k := range listaOrdenada {
			if(lista[k].tipo == x){
				var line []string

				s := strings.Replace(lista[k].preco, ",", ".", -1)
				f, _ := strconv.ParseFloat(s, 64)

				preco := big.NewFloat(f).Text('f', 2)

				switch(lista[k].tipo){
					case "F": line = append(line, "Filme")
					case "L": line = append(line, "Livro")
					case "S": line = append(line, "Serie")
				}
				line = append(line, lista[k].nome)
				line = append(line, generos[lista[k].genero])
				line = append(line, "R$"+preco)

				lines = append(lines, line)
			}
		}
	}

	createCsvFile(headers, lines, "4-wishlist.csv")
}

func emprestimos(lista map[string]Emprestimo){

	var listaOrdenada []string

	for i, k := range lista {

		now := time.Now()

		then, _ := time.Parse("02/01/2006" , k.devolucao)
		then = time.Date(then.Year(), then.Month(), then.Day(), now.Hour(), now.Minute(), now.Second(), now.Nanosecond(), now.Location())

		if(then.Before(now)){
			diff := now.Sub(then).Hours()/24

			k.atraso = int(diff)
						
			if(diff>(float64(k.atraso)+0.5)){
				k.atraso = k.atraso+1
			}		
			
			lista[i] = k		
		}

		listaOrdenada = append(listaOrdenada, i)
	}

/*
        for  i, k := range listaOrdenada{
		data1, _ := time.Parse("02/01/2006" , lista[k].emprestimo)
		y := i
		for  j := i+1; j<len(listaOrdenada); j++ {
			data2, _ := time.Parse("02/01/2006" , lista[listaOrdenada[j]].emprestimo)	
			if(data2.After(data1)){
				data1, _ = time.Parse("02/01/2006" , lista[listaOrdenada[j]].emprestimo)
				y = j
			}
			if(data2.Equal(data1)){
				//if(
			}
		}	
		x := listaOrdenada[i]
		listaOrdenada[i] = listaOrdenada[y]
		listaOrdenada[y] = x	
        }*/


 	 for  i, _ := range listaOrdenada{
		y := i
		for  j := i+1; j<len(listaOrdenada); j++ {
			data1, _ := time.Parse("02/01/2006" , lista[listaOrdenada[y]].emprestimo)
			data2, _ := time.Parse("02/01/2006" , lista[listaOrdenada[j]].emprestimo)	
			if(data2.After(data1)){
				y = j
			}
			if(data2.Equal(data1)){
				if(lista[listaOrdenada[j]].pessoa < lista[listaOrdenada[y]].pessoa){
					y = j
				}
			}
		}	
		x := listaOrdenada[i]
		listaOrdenada[i] = listaOrdenada[y]
		listaOrdenada[y] = x	
        }

	headers := []string{"Data do Emprestimo","Tomador","Se esta atrasado","Quantidade de dias atrasado"} 

	var lines [][]string
	
	for _, k := range listaOrdenada {
		var line []string

		line = append(line, lista[k].emprestimo)
		line = append(line, lista[k].pessoa)
		if(lista[k].atraso == 0){
			line = append(line, "Não")
		}else{
			line = append(line, "Sim")
		}
		line = append(line, strconv.Itoa(lista[k].atraso))

		lines = append(lines, line)
	}

	createCsvFile(headers, lines, "3-emprestimos.csv")

}

func main() {

	if len(os.Args) < 9 {
		log.Fatal("You need to set the filename\nexample: ./example sample.csv")
	}

	listaGeneros := make(map[string]string)
	listaPessoas := make(map[string]string)
	listaMidias := make(map[string]Midia)
	listaEmprestimos := make(map[string]Emprestimo)	

	for i:=1; i < len(os.Args)-1; i+=2{
		fileName := os.Args[i+1]

	    	switch os.Args[i] {
	   		case "-g":
				generos := readCSV(fileName)
				for i:=1; i < len(generos); i++{
					line := strings.Split(generos[i][0], ";")
					listaGeneros[line[0]] = line[1]						
				}
				
			case "-p":
				pessoas := readCSV(fileName)
				for i:=1; i < len(pessoas); i++{
					line := strings.Split(pessoas[i][0], ";")	
					listaPessoas[line[0]] = line[1]						
				}
			case "-m":
				midias := readCSV(fileName)
				for i:=1; i < len(midias); i++{
					line := strings.Split(midias[i][0], ";")
					novo := Midia{line[1],line[2],line[3],line[4],line[5],line[6],line[7],line[8],line[9],line[10],line[11],line[12]}
					listaMidias[line[0]] = novo	
				}
			case "-e":
				emprestimos := readCSV(fileName)
				for i:=1; i < len(emprestimos); i++{
					line := strings.Split(emprestimos[i][0], ";")
					novo := Emprestimo{line[1],line[2],line[3],0}
					listaEmprestimos[line[0]] = novo				
				}
		}

	}

	wishlist(listaMidias, listaGeneros)

	emprestimos(listaEmprestimos)
}

func readCSV(fileName string) [][]string{

        file, err := os.Open(fileName)

        if err != nil {
                log.Fatal("Error:", err)
        }

        defer file.Close()

        reader := csv.NewReader(file)

     	reader.Comma = 0;
        reader.TrimLeadingSpace = true

        lines, err := reader.ReadAll()

        if err != nil {
                log.Fatal("Error reading all lines: ", err)
        }

	return lines
}

func createCsvFile(headers []string, lines [][]string, fileName string) {

        file, _ := os.Create(fileName)

        writer := csv.NewWriter(file)

        writer.Write(headers)
        writer.WriteAll(lines)

        writer.Flush()

        file.Close()
}
